From 70ff175b1db43c718065726c95dec5978a947d74 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: Jun 21 2017 13:40:40 +0000
Subject: [PATCH 870/1001] Get the saved notifs from a different source in the feed


---

diff --git a/hubs/static/client/app/components/feed/Panel.jsx b/hubs/static/client/app/components/feed/Panel.jsx
index af5f440..80bed1c 100644
--- a/hubs/static/client/app/components/feed/Panel.jsx
+++ b/hubs/static/client/app/components/feed/Panel.jsx
@@ -11,7 +11,7 @@ export default class Panel extends React.Component {
       <div className="media py-3" id={this.props.item.id}>
         <Icon item={this.props.item} />
         <Markup {...this.props} />
-        { (this.props.handleSave) &&
+        { (this.props.handleSave || this.props.handleUnsave) &&
           <Actions {...this.props} />
         }
       </div>
diff --git a/hubs/static/client/app/core/Streams.jsx b/hubs/static/client/app/core/Streams.jsx
index fa257f9..144fab7 100644
--- a/hubs/static/client/app/core/Streams.jsx
+++ b/hubs/static/client/app/core/Streams.jsx
@@ -14,45 +14,39 @@ export default class Streams extends React.Component {
   constructor(props) {
     super(props);
     this.state = {
-      items: {
-        "notif": [],
-        "action": [],
-      },
+      notifItems: [],
+      savedItems: [],
       sseActive: false,
     };
     this.handleInitialData = this.handleInitialData.bind(this);
+    this.handleInitialSavedData = this.handleInitialSavedData.bind(this);
     this.handleMessage = this.handleMessage.bind(this);
     this.handleSave = this.handleSave.bind(this);
     this.handleUnsave = this.handleUnsave.bind(this);
   }
 
   handleInitialData(data) {
-    var newItems = {
-        notif: data.notif,
-        action: data.action,
-      };
     // Only activate SSE after the initial loading, or new elements may
     // be overwritten.
     this.setState({
-      items: newItems,
+      notifItems: data,
       sseActive: true,
     });
   }
 
+  handleInitialSavedData(data) {
+    this.setState({savedItems: data});
+  }
+
   handleMessage(msg) {
-    var items = this.state.items[msg.type];
-    if (items.length >= this.props.messageLimit) {
-      items.pop();
-    }
+    var items = this.state.notifItems;
     items.unshift(msg);
-    this.setState((prevState, props) => {
-      prevState.items[msg.type] = items;
-      return {items: prevState.items};
-    });
+    items = items.slice(0, this.props.messageLimit);
+    this.setState({notifItems: items});
   }
 
   handleSave(item) {
-    if (!this.props.urls.save) { return; }
+    if (!this.props.urls.saved) { return; }
     const payload = {
       link: item.link,
       markup: item.markup,
@@ -61,97 +55,93 @@ export default class Streams extends React.Component {
     };
     $.ajax({
       type: 'POST',
-      url: this.props.urls.save,
+      url: this.props.urls.saved,
       data: JSON.stringify(payload),
       contentType: 'application/json',
-      success: () => {
+      success: (data) => {
         this.setState((prevState, props) => {
-          var items = prevState.items.notif.map((currentItem) => {
-            if (currentItem.dom_id === item.dom_id) {
-              currentItem.saved = true;
-            }
-            return currentItem;
-          })
-          prevState.items.notif = items;
-          return {items: prevState.items};
+          prevState.savedItems.push(data.data);
+          return {savedItems: prevState.savedItems};
         });
       },
     });
   }
 
   handleUnsave(item) {
-    if (!this.props.urls.save) { return; }
-    var updateItemState = (item) => {
+    if (!this.props.urls.saved) { return; }
+    var updateSavedItems = (item) => {
       this.setState((prevState, props) => {
-        var items = prevState.items.notif.map((currentItem) => {
-          if (currentItem.dom_id === item.dom_id) {
-            currentItem.saved = false;
-          }
-          return currentItem;
-        });
-        prevState.items.notif = items;
-        return {items: prevState.items};
+        var items = prevState.savedItems.filter(
+          (currentItem) => (currentItem.dom_id !== item.dom_id)
+        );
+        return {savedItems: items};
       });
     };
     if (item.idx) {
       // Already saved
       $.ajax({
         type: 'DELETE',
-        url: `${this.props.urls.save}${item.idx}/`,
-        success: () => { updateItemState(item) },
+        url: `${this.props.urls.saved}${item.idx}/`,
+        success: () => { updateSavedItems(item) },
       });
     } else {
-      updateItemState(item);
+      updateSavedItems(item);
     }
   }
 
   render() {
-    var saved = [];
-    if (this.state.items.notif) {
-      saved = this.state.items.notif.filter((item) => (item.saved));
-    }
+    // Add saved state.
+    var savedItemsIds = this.state.savedItems.map((item) => {
+      return item.dom_id;
+    });
+    var notifs = this.state.notifItems.map((item) => {
+      item.saved = (savedItemsIds.indexOf(item.dom_id) !== -1);
+      return item;
+    });
 
     return (
       <IntlProvider locale={navigator.language}>
-        <ItemsGetter
-          sseActive={this.state.sseActive}
-          urls={this.props.urls}
-          handleMessage={this.handleMessage}
-          handleInitialData={this.handleInitialData}
-          >
-          <TabSet tabListClass="mb-3">
-            <FeedPanel
-              hub={this.props.hub}
-              tabTitle="My Stream"
+        <TabSet tabListClass="mb-3">
+          <FeedPanel
+            hub={this.props.hub}
+            tabTitle="My Stream"
+            >
+            <ItemsGetter
+              sseActive={this.state.sseActive}
+              urls={this.props.urls}
+              handleMessage={this.handleMessage}
+              handleInitialData={this.handleInitialData}
               >
               <Feed
-                items={this.state.items.notif}
+                items={notifs}
                 handleSave={this.handleSave}
                 handleUnsave={this.handleUnsave}
                 />
-            </FeedPanel>
-            <FeedPanel
-              hub={this.props.hub}
-              tabTitle="My Actions"
+            </ItemsGetter>
+          </FeedPanel>
+          <FeedPanel
+            hub={this.props.hub}
+            tabTitle="My Actions"
+            >
+            <Feed
+              items={this.state.notifItems}
+              />
+          </FeedPanel>
+          <FeedPanel
+            hub={this.props.hub}
+            tabTitle="Saved Notifications"
+            >
+            <ItemsGetter
+              urls={{content: this.props.urls.saved}}
+              handleInitialData={this.handleInitialSavedData}
               >
               <Feed
-                items={this.state.items.action}
-                handleSave={this.handleSave}
-                handleUnsave={this.handleUnsave}
-                />
-            </FeedPanel>
-            <FeedPanel
-              hub={this.props.hub}
-              tabTitle="Saved Notifications"
-              >
-              <Feed
-                items={saved}
-                handleSave={this.handleSave}
+                items={this.state.savedItems}
                 handleUnsave={this.handleUnsave}
                 />
-            </FeedPanel>
-          </TabSet>
-        </ItemsGetter>
+            </ItemsGetter>
+          </FeedPanel>
+        </TabSet>
       </IntlProvider>
     );
   }
diff --git a/hubs/views/user.py b/hubs/views/user.py
index 0a15cac..d40e393 100644
--- a/hubs/views/user.py
+++ b/hubs/views/user.py
@@ -18,18 +18,10 @@ from hubs.utils.views import (
 def stream(name):
     hub = get_hub(name)
     widgets = get_visible_widgets(hub)
-    saved = hubs.models.SavedNotification.by_username(name)
-    saved = [n.__json__() for n in saved]
-
-    stream = hubs.stream.Stream()
-    actions = stream.get_json()
-
     return flask.render_template(
         'stream.html',
         hub=hub,
         widgets=widgets,
-        saved=json.dumps(saved),
-        actions=actions
     )
 
 
@@ -39,22 +31,23 @@ def stream_existing(name):
     hub = get_hub(name)
     stream = hubs.stream.Stream()
     existing = json.loads(stream.get_json())
-    saved = [s.dom_id for s in
-             hubs.models.SavedNotification.by_username(name)]
-    for e in existing:
-        e["saved"] = (e["dom_id"] in saved)
     # Right now, stream and actions are the same.
     # Once mentions is implemented, then each will be its own.
     return flask.jsonify(dict(
-        status="OK", data=dict(notif=existing, action=existing),
+        status="OK", data=existing,
         ))
 
 
-@app.route('/<user>/notifications', methods=['POST'])
-@app.route('/<user>/notifications/', methods=['POST'])
+@app.route('/<user>/notifications', methods=['GET', 'POST'])
+@app.route('/<user>/notifications/', methods=['GET', 'POST'])
 @login_required
 def notifications(user):
-    if flask.request.method == 'POST':
+    if flask.request.method == "GET":
+        saved = hubs.models.SavedNotification.by_username(user)
+        return flask.jsonify(dict(
+            status="OK", data=[n.__json__() for n in saved],
+            ))
+    elif flask.request.method == "POST":
         data = flask.request.get_json()
         user = hubs.models.User.by_username(user)
         if not user:

